package tnntpd;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;

public class OrderPreservingMap implements Iterable<String> {

  private HashMap<String,String> map = new HashMap<String,String> () ;
  private LinkedList<String> order = new LinkedList<String> () ;
  
  public void append ( String key, String value ) {
    map.put(key.toUpperCase(),value) ;
    order.addLast(key) ;
  }
  
  public String get ( String key ) {
    return map.get(key.toUpperCase()) ;
  }
  
  public boolean containsKey ( String key ) {
    return map.containsKey(key.toUpperCase()) ;
  }
  
  public Iterator<String> iterator() {
    return order.iterator() ;
  }
  
  public void set ( String key, String value ) {
    if ( ! containsKey ( key ) ) order.addLast(key) ; 
    map.put(key.toUpperCase(),value) ;
  }
  
}
