package tnntpd.command;

import java.io.IOException;
import tnntpd.Group;

public class GroupCommand extends Command {

  public static boolean process ( String[] command ) throws IOException {
    String commandName = command[0] ;
    if ( ! commandName.equalsIgnoreCase("GROUP") ) return false ;
    // untested, RFC977 complient
    Group g = null;
    if ( command.length >= 2 ) {
      g = Group.getByName ( command[1] ) ;
    }
    if ( g == null ) {
      printStatus ( 411, "no such news group" );
      return true;
    }
    setCurrentGroup ( g ) ;
    printStatus (211, g.getEstimatedArticleCount() + " " + g.getFirstArticle() + " " + g.getLastArticle() + " " + g.getName() + " group selected" ) ;    
    return true ;
  }
  
}
